package  nstat.patch;

import 	  jam.vector.*;
import 	  jam.operator.*;
import    rsf.vector.*;

/**
 * This demonstrates the problem of a push operator with insufficient overlap.
 * I could change this to using a Patcher object. 
 *
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author: Matthias Schwab 
 */
final
public class Cinloip {
  public static void main( String[] args) {
    // user choice // 
    Rsf  iqlt = RsfFactory.newRsf(100,30);  iqlt.fill(1f);
    Rsf  wght = RsfFactory.newRsf(100,30);
    Rsf  oqlt = RsfFactory.newRsf(100,30);

    int[]  ws = {17,6};
    int[] ian = {0,0};

    Rsf  iptch, optch;

    // does the forward patching //
    Window trunc 
      = new WindowFactory((RsfSpace) iqlt.getSpace(),  ian, ws).getForward();

    // simulates an operator with small opatch but the same space // 
    int[] os  = {6,2};
    int[] oan = {0,0};
    Window opFwd
      = new WindowFactory((RsfSpace) trunc.getRange(), oan, os).getForward();

    // does the adjoint patching // 
    Window zpadd
      = new WindowFactory((RsfSpace) iqlt.getSpace(),  ian, os).getAdjoint();

    Rsf pwght = (Rsf) opFwd.getRange().newMember(); 
    rsf.util.Tent.setTent(pwght); 

    for(int i1=0; i1< 6; i1++) { ian[1] =     (int) (4.9*i1); oan[1]=ian[1]+2;
    for(int i0=0; i0< 5; i0++) { ian[0] = 2 + (int) (20 *i0); oan[0]=ian[0]+2;
      trunc.setAnchor(ian);
      iptch = (Rsf) trunc.image(iqlt); 
      optch = (Rsf) opFwd.image(iptch); 
      zpadd.setAnchor(oan); 
      optch.mul(pwght);
      zpadd.addImage(optch,oqlt);
      zpadd.addImage(pwght,wght);
    }}
    rsf.operator.ElwInv.elwInv(wght,1.0e-12f);
    oqlt.mul(wght); 
    oqlt.write(System.out);
  }
}






