package  nstat.patch;
import 	  jam.vector.*;
import 	  jam.operator.*;
import    rsf.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author: Matthias Schwab 
 */
final
public class Idempatcher {
  public static void main( String[] args) {
    Rsf   iqlt = RsfFactory.newRsf(100,30);
    Rsf   oqlt = RsfFactory.newRsf(100,30);
    Rsf   wght = RsfFactory.newRsf(100,30);
    iqlt.fill(1f);
    float[] ow = {-0.05f, 0.1f};
    int  [] ws = {17,6};
    Rsf   ptch = RsfFactory.newRsf(ws);
    ptch.fill(1f); 

    PatcherFactory pwFac = new PatcherFactory((RsfSpace)iqlt.getSpace(),ws,ow);
    for (Patcher pw = pwFac.getPatcher(); pw.hasMoreElements(); ) {
      Window cut   = (Window) pw.nextElement();
      Window paste = (Window) cut.adjoint();
      paste.addImage(cut.image(iqlt), oqlt);
      paste.addImage(          ptch , wght);
    }
    rsf.operator.ElwInv.elwInv(wght,1.0e-12f); // avoids division by 0 // 
    oqlt.mul(wght); 
    oqlt.write(System.out);
  }
}

