package  nstat.patch;

import   java.util.Enumeration;
import  juice.util.JuiceUtil;
import    rsf.vector.*;
import    gag.xtp.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 * 
 * author: Joel Schroeder and Matt Schwab 
 */
public class PatcherDemo {
  public static void main(String[] args) {
    int[] wallSize = { 100, 120 };
    int[] windSize = {  20,  25 };

    // create the data input
    RsfSpace wallSpace = new RsfSpace(wallSize);
    Rsf wall = RsfFactory.newRsf(wallSpace);
    wall.fill(1F);
    // create the data output
    Rsf out   = RsfFactory.newRsf(wallSpace);
    out.zero();

    float[] ow = { .1f, .3f};
    PatcherFactory pwFac = new PatcherFactory(wallSpace, windSize, ow);
    Patcher pw = pwFac.getPatcher(); 

    // Prints out some stats .. 
    System.out.println("WallSpace: \n" + wallSpace + "\n");
    System.out.println("numWindows: "  + pw.getNPatches     (0) +
		       ", "             + pw.getNPatches     (1));
    System.out.println("overlap   : "   + pwFac.getOverlap(0) +
		       ", "             + pwFac.getOverlap(1));
    System.out.println("Note how the first dimension doesn't overlap");
    for ( ; pw.hasMoreElements(); ) {
      System.out.println("Anchor: " +
			 JuiceUtil.arrayToString(((Window) pw.nextElement())
					    .getAnchor(), ", "));
    }

    // cutting and pasting of the windows
    for ( Patcher pw2 = pwFac.getPatcher() ; pw2.hasMoreElements(); ) {
      Window cut   = (Window) pw2.nextElement();
      Window paste = (Window) cut.adjoint();
      paste.addImage(cut.image(wall), out);
    }
    out.neg();

    System.out.println(out);
    out.write("junk.H");
    RsfCanvas canv = new RsfCanvas(out, 200, 200, -5F, 0F);
    ResultFrame rf = new ResultFrame("Windowing example", canv);
    rf.resize(400, 300); 
    rf.show();
    System.out.println("The image should be horizontally striped.");
    System.out.println("The tiles do not overlap horizontally.");
    System.out.println("But they do overlap vertically.");
    System.out.println("Use control-c when done.");
  }
}

