package  nstat.patchF;

import 	  jam.vector.*;
import 	  jam.operator.*;
import  juice.util.JuiceUtil;
import    rsf.vector.Axis;
import 	  rsfF.vector.*;
import  juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final
public class PatchTest {
  public static void main( String[] args) {
    Axis[] ax = new Axis[1];
    ax[0] = new Axis( 4, 2f, 0f, "distance", "m" );

    int[] patchSize = { 2 };
    int[] anchor    = { 1 };

    Rsf quilt = (Rsf) new Rsf(ax);
    quilt.zero();
    for (int i = 0; i < quilt.getTotalNSamples(); i++)
      quilt.d[i] = (float) i;
    
    hasAdjoint myPatch =
      new PatchFactory((RsfSpace) quilt.getSpace(),
		       anchor, patchSize).getForward();
    Rsf patch = (Rsf) myPatch.image(quilt);

    boolean passed1 = true;

    passed1 = passed1 && (patch.d[0] ==  1F);
    passed1 = passed1 && (patch.d[1] ==  2F);

    System.out.println("QuiltRsf : " + quilt);
    System.out.println("PatchRsf : " + patch);
    System.out.println("Patch size, anchor = " +
		       patchSize[0] + " " + anchor[0]);

    // 3D test

    Axis[] ax3 = new Axis[3];
    ax3[0] = new Axis( 3, 1f, -4f, "time", "s" );
    ax3[1] = new Axis( 4, 2f, 12f, "distance", "m" );
    ax3[2] = new Axis( 5, 3f,  6f, "money", "$" );

    quilt = (Rsf) new Rsf(ax3);
    quilt.zero();
    int[] i = new int[3];
    for     (i[2] = 0; i[2] < 5; i[2]++)
      for   (i[1] = 0; i[1] < 4; i[1]++)
	for (i[0] = 0; i[0] < 3; i[0]++)
	  quilt.d[quilt.i(i)] = (float) (i[0] + 10*i[1] + 100*i[2]);

    int[] patchSize3 = { 2, 2, 3 };
    int[] anchor3    = { 1, 2, 0 };

    myPatch = new PatchFactory((RsfSpace) quilt.getSpace(),
			       anchor3, patchSize3).getForward();

    patch = (Rsf) myPatch.image(quilt);

    System.out.println("QuiltRsf  : " + quilt);
    System.out.println("PatchRsf  : " + patch);
    System.out.println("Patch size: " +
		       JuiceUtil.arrayToString(patchSize3, ", "));
    System.out.println("Anchor: "     +
		       JuiceUtil.arrayToString(anchor3, ", "));

    boolean passed3 = true;
    for     (i[2] = 0; i[2] < patchSize3[2]; i[2]++)
      for   (i[1] = 0; i[1] < patchSize3[1]; i[1]++)
	for (i[0] = 0; i[0] < patchSize3[0]; i[0]++)
	  passed3 = passed3 &&
	    (patch.d[patch.i(i)] == (float) ((    i[0]+anchor3[0]) +
					     10 *(i[1]+anchor3[1]) +
					     100*(i[2]+anchor3[2])));

    Tester.exit(passed1 && passed3);
  }
}
