package  nstat.patchF;

import   java.util.Enumeration;
import  juice.util.JuiceUtil;
import    rsfF.vector.*;
import    gag.xtpF.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class PatchworkDemo {
  public static void main(String[] args) {
    int[] quiltSize = { 100, 120 };
    int[] patchSize = {  20,  25 };

    RsfSpace quiltSpace = new RsfSpace(quiltSize);
    Patchwork pw = new Patchwork(quiltSpace, patchSize, 0.1F);
    pw.setOverlap(1, .3F);
    System.out.println("QuiltSpace: \n" + quiltSpace + "\n");
    System.out.println("numPatches: " + pw.getNPatches     (0) +
		       ", "           + pw.getNPatches     (1));
    System.out.println("overlap   : " + pw.getActualOverlap(0) +
		       ", "           + pw.getActualOverlap(1));
    for (Enumeration e = pw.getPatches(); e.hasMoreElements(); ) {
      System.out.println("Anchor: " +
			 JuiceUtil.arrayToString(((Patch) e.nextElement())
					    .getAnchor(), ", "));
    }
    System.out.println("Please wait ...");
    Rsf quilt = new Rsf(quiltSpace);
    quilt.fill(1F);
    Rsf out   = new Rsf(quiltSpace);
    out.zero();
    for (Enumeration e = pw.getPatches(); e.hasMoreElements(); ) {
      Patch cut   = (Patch)   e.nextElement();
      Patch paste = (Patch) cut.adjoint();
      paste.addImage(cut.image(quilt), out);
    }
    out.neg();
    RsfCanvas canv = new RsfCanvas(out, 200, 240, -5F, 0F);
    ResultFrame rf = new ResultFrame("Patching example", canv);
    rf.resize(400, 300);
    rf.show();
    System.out.println("Use control-c when done.");
  }
}
