package nstat.tvdeconF;

import	 jam.vector.*;
import	 jam.operator.*;
import	 rsfF.vector.*;
import juice.util.JuiceUtil;
import   sep.operator.SepLinearOperator;

/**
 * Free-mask for a prediction-error filter
 * <BR><!--#include file="./source.inc"--><BR>
 *
 * @author    Joel Schroeder
 */
public class PefFreeMask extends SepLinearOperator {
  protected int[] spot;

  // constructors
  /**
   * @param space     is the domain and range of the mask
   * @param spot      is the position of the pef's requisite 1
   */
  public PefFreeMask(RsfSpace space, int[] spot) {
    super(space, space);
    this.spot  = spot;
    setAdjoint(this);
  }

  public void apply( boolean add, Vector x, Vector y) {
    float[] d = ((Rsf) x).getData();
    float[] r = ((Rsf) y).getData();
    int spotIndex = ((RsfSpace) input).getIndex(spot);
    int last      = ((RsfSpace) input).getTotalNSamples();
    int i;
    if (add)
      for ( i = spotIndex + 1; i < last; i++)
	r[i] += d[i];
    else {
      for ( i = 0; i <= spotIndex; i++)
	r[i] = 0F;
      for (      ; i < last; i++)
	r[i] = d[i]; }}

  public int[] getSpot() { return spot; }
  public void  setSpot( int[] spot) { this.spot = spot; }

  public jam.JamObject copy() {
    System.err.println("PefFreeMask.copy() not yet implemented.\n");
    return null;
  }
  
  // I/O
  public String toString() {
    return ( "PefFreeMask\n" +
	     "Spot : ( " + JuiceUtil.arrayToString( spot, ", ") + ")\n" +
	     "Space:\n"  + getDomain()); }
}
