package nstat.var;

import   jam.vector.*;
import   rsf.vector.*;
import   rsf.operator.*; 
import   sep.io.ArgumentKeeper;
import  nstat.patch.*;

public class NStatVar {
  public static void main(String[] args) {
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);
    Rsf iput = RsfFactory.newRsf(System.in);
    // ipatch specs //
    float overlap   = argKeeper.getFloat   ("overlap"  , "0.5");
    System.err.println("overlap: "   + overlap     );
    int[] patchSize = argKeeper.getIntArray("patchsize", "321");
    System.err.println("patchSize: " + patchSize[0]);
    // patch weight // 
    Rsf     p    = RsfFactory.newRsf(patchSize);
    StatVar o    = new StatVar(p.getSpace(), "domain");
    Rsf     wptc = (Rsf) o.getRange().newMember();
    rsf.util.Tent.setTent(wptc);     
    // output quilt // 
    StatVar r    = new StatVar(iput.getSpace(), "domain");
    Rsf     oput = (Rsf) r.getRange().newMember();
    Rsf     wght = (Rsf) r.getRange().newMember(); 
    // ipatch loop  //
    PatcherFactory f = 
      new PatcherFactory((RsfSpace) iput.getSpace(), patchSize, overlap);
    Patcher  ptchr   = f.getPatcher();
    int numPatches   = ptchr.getNPatches();
    for (int i=1; ptchr.hasMoreElements(); i++) {
      //System.err.println("Doing patch #" + i + " of " + numPatches);
      Rsf iptc         = ptchr.nextPatch(iput); 
      StatVar oper     = new StatVar(iptc.getSpace(), "domain");
      Rsf optc         = (Rsf) oper.image(iptc);
      WindowFactory wf = new WindowFactory((RsfSpace) oput.getSpace(),
					   (RsfSpace) optc.getSpace());
      Window pad       = wf.getAdjoint();
      optc.mul(wptc);
      pad.addImage(optc,oput); 
      pad.addImage(wptc,wght); // Window Operator ignores Space consistency!
    }
    oput.write("stck.H"); iput.write("iput.H");   
    rsf.operator.ElwDiv.elwDiv(oput,oput,wght);
    oput.write("oput.H"); wght.write("weight.H");
  }
}

