package nstat.var;

import   jam.vector.*;
import   rsf.vector.*;
import   rsf.operator.*; 
import   sep.io.ArgumentKeeper;
import  nstat.patch.*;

public class NStatVarEnum {
  public static void main(String[] args) { 
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);   // reads args  
    Rsf     iput = RsfFactory.newRsf(System.in); 
    float   olap = argKeeper.getFloat   ("overlap"  , "0.5"); 
    int[]   psze = argKeeper.getIntArray("patchsize", "321");
    Rsf     p    = RsfFactory.newRsf(psze);                // computes 
    StatVar o    = new StatVar(p.getSpace(), "domain");    // patch weights
    Rsf     wptc = (Rsf) o.getRange().newMember();
    rsf.util.Tent.setTent(wptc);     
    StatVar r    = new StatVar(iput.getSpace(), "domain"); // computes 
    Rsf     oput = (Rsf) r.getRange().newMember();         // output   
    Rsf     wght = (Rsf) r.getRange().newMember();         // Space    

    PatcherFactory   f =                                    // loop 
      new PatcherFactory((RsfSpace) iput.getSpace(), psze, olap);
    Patcher       pchr = f.getPatcher();
    for (int i=1; pchr.hasMoreElements(); i++) {
      Rsf         iptc = pchr.nextPatch(iput);              // get    patch
      StatVar     oper = new StatVar(iptc.getSpace(), "domain");
      Rsf         optc = (Rsf) oper.image(iptc);            // image  patch
      WindowFactory wf = new WindowFactory((RsfSpace) oput.getSpace(),
					   (RsfSpace) optc.getSpace());
      Window pad       = wf.getAdjoint();
      optc.mul(wptc);                                       // weight patch
      pad.addImage(optc,oput);                              // add    patch
      pad.addImage(wptc,wght);  // Window Operator ignores Space consistency!
    }
    oput.write("stck.H"); iput.write("iput.H");  
    rsf.operator.ElwDiv.elwDiv(oput,oput,wght);        // apply quilt weight
    oput.write("oput.H"); wght.write("wght.H");        
  }
}

