package nstat.var;

import   jam.vector.*;
import   rsf.vector.*;
import   rsf.operator.*; 
import   sep.io.ArgumentKeeper;
import  nstat.patch.*;

public class NStatVarWind {
  public static void main(String[] args) { 
    ArgumentKeeper argKeeper = new ArgumentKeeper(args);      // reads args  
    Rsf        iput = RsfFactory.newRsf(System.in); 
    int[]      psze = argKeeper.getIntArray("patchsize", "321");
    Rsf        p    = RsfFactory.newRsf(psze);                // computes 
    StatVar    o    = new StatVar(p.getSpace(), "domain");    // patch weights
    Rsf        wptc = (Rsf) o.getRange().newMember();
    rsf.util.Tent.setTent(wptc);     
    StatVar    r    = new StatVar(iput.getSpace(), "domain"); // computes 
    Rsf        oput = (Rsf) r.getRange().newMember();         // output   
    Rsf        wght = (Rsf) r.getRange().newMember();         // Space    

    int[] an = {0};                                           // get anchor 
    Window trunc 
      = new WindowFactory((RsfSpace) iput.getSpace(), an, psze).getForward();
    for (int i=0; i < 15; i++) { an[0] = (int) (73.3 * i); 

      trunc.setAnchor(an); 
      Rsf         iptc = (Rsf) trunc.image(iput);             // get    patch
      StatVar     oper = new StatVar(iptc.getSpace(), "domain"); 
      Rsf         optc = (Rsf) oper.image(iptc);              // image  patch
      WindowFactory wf = new WindowFactory((RsfSpace) oput.getSpace(),
					   (RsfSpace) optc.getSpace());
      Window zpadd     = wf.getAdjoint();
      optc.mul(wptc);                                         // weight patch
      zpadd.addImage(optc,oput);                              // add    patch
      zpadd.addImage(wptc,wght);  // Window Operator ignores Space consistency!
    }
    oput.write("stck.H"); iput.write("iput.H");  
    rsf.operator.ElwDiv.elwDiv(oput,oput,wght);          // apply quilt weight
    oput.write("oput.H"); wght.write("wght.H");        
  }
}

